# WinMerge 2.16.18 リリースノート

- [このリリースについて](#about-this-release)
- [2.16.18の新機能](#what-is-new-in-21618)
- [2.16.17 beta の新機能](#what-is-new-in-21617-beta)
- [既知の問題](#known-issues)

2022年1月

## このリリースについて

WinMerge の 2.16.18 安定版リリースです。
このリリースは、以前の WinMerge 安定版リリースに代わる推奨リリースです。

不具合は <a href="http://github.com/WinMerge/winmerge/issues">bug-tracker</a> で報告してください。
日本語での報告は、<a href="https://osdn.net/projects/winmerge-jp/ticket/">こちら</a>でお願いします。

## 2.16.18 の新機能

### 全般

- 不具合修正: Googleドライブのファイルを比較するとクラッシュすることがある。
- タブバーのツールチップにフルパス名、使用しているプラグイン、行フィルタ等で無視されている行があるかどうかを表示するようにした。 (#960)
- Contributors.txt に漏れていた人の名前を追加 (PR #1094)
- View→Select Fontメニュー項目から表示されるフォント選択ダイアログを表示している間は、親ウィンドウを操作できないようにしました。

### ファイル比較

- 不具合修正: ファイルサイズによってはクラッシュすることがあった。 (#1101)
- 不具合修正: [ウインドウ]→[分割]メニューでウインドウを分割した後、ペインの高さをドラッグ操作で０にしたとき、エラーが発生する。
- 不具合修正: オプションダイアログの[色/差異]カテゴリで単語の差異のテキストの色を指定しても反映されなかった。 (#1116)
- 3ファイル比較: 隣接ペインだけでなく、直接左側ペインから右側ペインまたは逆方向にコピーできるようにした。(コンテキストメニューまたは[マージ]→[高度な操作]から) (#957)
- [行を右端で折り返す]を有効にしている場合、非常に長い行があるとハングアップしているように見えるほど遅くなることがあるのを少し改善した。 (#1111)
- ステータスバーのエンコーディングをダブルクリックした時、表示されるコードページウインドウの[反映先]がダブルクリックした側のペインだけチェックが付くようにした。 (#793)

### クリップボード比較

- 新機能: クリップボード比較 (PR #1147)
  - [ファイル]→[クリップボードを開く]メニューを選択すると、クリップボード履歴の直近の2つの内容を比較することができるようになりました。
  - 子MDIウィンドウが表示されていないときにCtrl+Vキーを押しても比較できます。
  - この機能は、Windows 10 version 1809 以降と WinMerge 64bit版でのみ有効です。

### フォルダ比較

- 不具合修正: 3フォルダ比較時、比較結果列のソート順が2フォルダ比較と異なっていた。 (#483)
- 不具合修正: フォルダー比較ウィンドウで "選択された項目を更新 "を実行すると WinMerge がクラッシュする場合があった。 (PR #1120)
- 不具合修正: 非再帰的比較時、親フォルダへ移動するアイコンが表示されなかった。
- 不具合修正: 2.16.17 で以前のバージョンと異なりソート順が逆になっていた。

### プラグイン

- [その他のプラグイン]メニューの名前をを[すべてのプラグイン]に変更。 (#1139,PR #1140)
- プラグインの説明を翻訳可能にした。
- Apache Tika のバージョンを 2.2.1 に更新。

### コマンドライン

- クリップボード比較のコマンドラインオプション(`/clipboard-compare`)を追加

### アーカイブサポート

- 7-Zip 21.07 に更新。

### インストーラ

- 不具合修正: ReadMe.txtのクイックスタートのリンクが間違っていた。 (#1127)
- 不具合修正: 32bit版のWinMergeインストール後、64bit版のWinMergeを上書きインストールすると 7z.dll が上書きされなかった。
- Windows11ではWindows11向けシェルエクステンションをインストールするようにした。

### マニュアル

- 不具合修正: 「4.8 クイック比較切替閾値」と「4.9 バイナリ比較切替閾値」の説明が間違っていたのを修正。 (#1100)

### 翻訳

- 翻訳の更新:
  - Chinese Simplified (PR #1109,#1112,#1134)
  - Corsican (PR #1103,#1119,#1137,#1142,#1154)
  - Dutch (PR #1123)
  - French (PR #1121,#1122,#1157)
  - German (PR #1110,#1117,#1143,#1155)
  - Hungarian (PR #1102,#1115,#1136,#1141,#1150)
  - Japanese
  - Lithuanian (PR #1124,#1144)
  - Portuguese (PR #1097,#1098,#1106,#1133,#1149)
  - Slovenian (PR #1148,#1153)
  - Turkish (PR #1099)

### 内部変更

- DirScan.cpp のタイポ修正 (PR #1118)

## 2.16.17 Beta の新機能

### 全般

- 比較オプションとして[数字を無視]を追加。 (PR #1025,#923)
- タブバーのタブにタイトルが長すぎて表示しきれない場合、ツールチップで表示するようにした。 (PR #1038)
- 「'Esc'キーでウインドウを閉じる」コンボボックスに「MDI子ウインドウが１つしかない場合、メインウインドウを閉じる」を追加。 (#1052)
- INIファイル(WinMergeU.exeと同じ場所のwinmerge.ini)に[Defaults]セクションとキー=値を記載した場合、WinMerge終了前に設定変更していても次回起動時記載した設定値で上書きするようにした。(#1038)

### ファイル比較

- 不具合修正: 64MBを超えるファイルを開くと表示されるウインドウで[はい]を選択するとクラッシュする。 (#1036)
- 不具合修正: C#(Java, JavaScript)のキーワードハイライトを修正。 (#1040)
- 不具合修正: WinMergeで編集中のファイルを他のアプリケーションで変更後、WinMergeに戻るとフォーカスしているペインが変わってしまう。 (#1050)
- 不具合修正: PHPのシンタックスハイライトを修正。 (PR #1055)
- 不具合修正: 片方のファイルにコメントのみの行があり、他方のファイルには対応する行が存在しない場合、[コメントの違いを無視する]と[空行を無視する]オプション両方が有効になっていれば、この差異を無視するようにした。 (#1057)
- 比較オプションとして[数字を無視]を追加。 (PR #1042)
- [比較/一般]カテゴリの"類似行をマッチさせる"オプションの動作を若干改善 (#1013)
- 3ファイル比較でも"類似行をマッチさせる"オプションを機能させるようにした。
    (PR #1051,#510)
- 行フィルタ、置換フィルタ等で差異を無視した行が存在する場合、タイトルに"(F)"を付加するようにした。 (#1056)

### 画像比較

- 複数ページある画像ファイルの前ページを1つの比較レポートに出力できるようにした。(現在のページのみ出力したい場合は、名前を付けて保存ダイアログで「すべてのページ」のチェックを外してください) (osdn.net #43374)

### フォルダ比較

- 不具合修正: 内容が同じでファイル名が異なるファイルに対して、重複グループ番号が割り当てられなかった。
- 不具合修正: 追加プロパティがある場合に3フォルダ比較でクラッシュする。
- ツリーモードが無効の時に大量のファイルを比較すると結果が表示されるまでかなり時間がかかるのを改善した。 (#PR #1069)

### プロジェクトファイル

- プロジェクトファイルに「数字を無視」の設定を保存できるようにした。 (PR #1068)

### パッチ生成ダイアログ

- [クリップボードにコピー]チェックボックスを追加。 (#923)

### プラグイン

- 不具合修正: 不具合修正: [プラグイン]→[プラグインの再読み込み]メニューでプラグインの再読み込みがされていなかった

### アーカイブサポート

- 7-Zip 21.06 に更新。

### シェルエクステンション

- Windows11のシェルエクステンション: 現在のWindows11 Build 22000とBuild 22499で問題なそうなので無効にしていた拡張メニューを復活させた。

### 翻訳

- 追加された翻訳:
  - Corsican (PR #1072,#1085)
- 翻訳の更新:
  - Chinese Traditional (PR #1079)
  - Galician (PR #1089)
  - German (PR #1062,#1086,#1088) 
  - Hungarian (PR #1032)
  - Japanese
  - Korean (PR #1078)
  - Lithuanian (PR #1043,#1061,#1082,#1087)
  - Polish (PR #1049)
  - Portuguese (PR #1034,#1039,#1060,#1065)
  - Russian (PR #1031)
  - Slovenian

### 内部変更

- 不具合修正: BCMenu.cpp 内のタイポ修正 (PR #1054)
- 不具合修正: Return better HRESULTs (PR #1077)
- ARM32アーキテクチャ向けのビルドができるようにした。

## 既知の問題

 - 巨大ファイルの比較でクラッシュすることがある。(GitHub #325)
 - 大幅に異なるフォルダの比較が非常に時間がかかる。 (GitHub #322)
 - 新規作成で表示範囲を超えるテキストを貼り付けたとき、垂直スクロールバーでスクロールできない。 (GitHub #296)
